﻿namespace etoy
{
    class TxtVersionConfigGenerater : IGenerater
    {
        public void Generate(Context context)
        {
            int metadataCount = 0;
            foreach (var metadata in context.Blackboard.MetadataTables)
                metadataCount += metadata.Structs.Count;

            int keyValueCount = 0;
            foreach (var kv in context.Blackboard.KeyValueTables)
                keyValueCount += kv.Rows.Length;

            var dateTime = DateTimeUtility.GetDateTime(context.Blackboard.Timestamp);

            using var writer = new CodeWriter(context.Option.ConfigVersionOutput);
            writer.WriteLine("* POWER BY ETOY *");
            writer.WriteLine();
            writer.WriteLine($"# Version  : {context.Blackboard.Version}");
            writer.WriteLine($"# Tables   : {context.Blackboard.Tables.Count}");
            writer.WriteLine($"# Metadata : {metadataCount}");
            writer.WriteLine($"# KeyValue : {keyValueCount}");
            writer.WriteLine($"# Time     : {dateTime}");
        }
    }
}