﻿using Microsoft.VisualBasic.FileIO;

namespace etoy
{
    static class FieldTypeDefine
    {
        public const string Int = "int";
        public const string Long = "long";
        public const string Boolean = "bool";
        public const string String = "string";
        public const string Float = "float";
        public const string Double = "double";
    }
    /// <summary>
    /// TypeScript类型定义
    /// </summary>
    static class TSTypeDefine
    {
        public const string Number = "number";
        public const string String = "string";
        public const string Boolean = "boolean";
        /// <summary>
        /// FieldTypeDefine -> TSTypeDefine
        /// </summary>
        /// <param name="fieldType"></param>
        /// <returns></returns>
        public static string ToTSFieldType(this string fieldType)
        {
            string result = fieldType switch
            {
                FieldTypeDefine.Int or FieldTypeDefine.Long or FieldTypeDefine.Float or FieldTypeDefine.Double => Number,
                FieldTypeDefine.Boolean => Boolean,
                _ => fieldType,
            };
            return result;
        }
    }


    static class SqliteTypeDefine
    {
        public const string Integer = "integer";
        public const string Integer64 = "integer64";
        public const string Float = "float";
        public const string Varchar = "varchar";
    }

    /// <summary>
    /// 规则中心类型
    /// </summary>
    static class RuleCenterTypeDefine
    {
        public const string Int = "int";
        public const string Tinyint = "tinyint";
        public const string Varchar = "varchar";
        public const string Bigint = "bigint";
        public const string Double = "Double";
        public const string Longtext = "longtext";
    }

    /// <summary>
    /// 规则中心Json结构
    /// </summary>
    static class RuleCenterJsonStructureDefine
    {
        public const string Tag = "tag";
        public const string ProjectName = "project_name";
        public const string SettingVersion = "setting_version";
        public const string ProjectVersion = "project_version";
        public const string UpdateTime = "update_time";
        public const string Mode = "mode";
        public const string Tables = "tables";

        public const string Table_Name = "name";

        public const string Table_Fields = "fields";
        public const string Table_Fields_Name = "name";
        public const string Table_Fields_Type = "type";
        public const string Table_Fields_Length = "length";

        public const string Table_Rows = "rows";

        /// <summary> kv表统一字段名:Key </summary>
        public const string KVTable_Key = "Key";
        /// <summary> kv表统一字段名:Value</summary>
        public const string KVTable_Value = "Value";
        /// <summary> kv表统一字段名:Type</summary>
        public const string KVTable_Type = "Type";
        /// <summary> kv表统一字段名:Description </summary>
        public const string KVTable_Description = "Description";
    }
}
