﻿using XGame.Framework.Serialization;

namespace etoy
{
    /// <summary>
    /// 可序列化对象数组
    /// 按照数组类型序列化数据
    /// 和Group不同，group是属性的集合，序列化时按顺序序列化属性
    /// </summary>
    class SerializableArray : ISerializable
    {
        public List<ISerializable> fields = new List<ISerializable>();
        void ISerializable.Deserialize(IReader reader)
        {
            fields = reader.ReadEnumerable<List<ISerializable>>();
        }

        void ISerializable.Serialize(IWriter writer)
        {
            writer.Write(fields);
        }
    }
}
