﻿namespace etoy
{
    class CmdCheckEnvironment : Command
    {
        public override string Description => "程序环境检测";

        protected override void OnProcess()
        {
            SetProgress(0F);

            //if (!Directory.Exists(Context.Option.CsvOutput))
            //    throw new Exception("配置表CSV文件夹不存在");

            SetProgress(0.2F);

            var pipelineType = (PipelineType)Context.Option.PipelineType;
            if (pipelineType is PipelineType.All or PipelineType.Client)
            {
                if (Directory.Exists(Context.Option.ClientCodeOutput))
                    foreach (string file in Directory.GetFiles(Context.Option.ClientCodeOutput, "*.cs", SearchOption.AllDirectories))
                        File.Delete(file);
                Directory.CreateDirectory(Context.Option.ClientCodeOutput);
                SetProgress(0.4F);
                if (File.Exists(Context.Option.ClientDatabaseOutput))
                    File.Delete(Context.Option.ClientDatabaseOutput);
            }
            if (pipelineType is PipelineType.All or PipelineType.Server)
            {
                if (!Directory.Exists(Context.Option.ServerCodeOutput))
                { // 服务端的代码路径下可能有其它脚本，只能替换不能删文件夹
                    Directory.CreateDirectory(Context.Option.ServerCodeOutput);
                }
                SetProgress(0.6F);
                if (File.Exists(Context.Option.ServerDatabaseOutput))
                    File.Delete(Context.Option.ServerDatabaseOutput);
            }
            Completed();
        }
    }
}