﻿using System;

namespace etoy
{
    class DateTimeUtility
    {

        /// <summary>
        /// 获取时间戳 (单位: 秒)
        /// </summary>
        /// <param name="isLocal">是否为本地时间, 否则为UTC时间</param>
        /// <returns></returns>
        public static long GetUnixTimeStamp(bool isLocal = true)
        {
            var timeZone = isLocal ? TimeZoneInfo.Local : TimeZoneInfo.Utc;
            DateTime startTime = TimeZoneInfo.ConvertTimeFromUtc(new DateTime(1970, 1, 1, 0, 0, 0), timeZone);// 当地时区
            long UnixTimeStamp = (long)(DateTime.Now - startTime).TotalSeconds; // 相差秒数
            return UnixTimeStamp;
        }

        /// <summary>
        /// 获取日期
        /// </summary>
        /// <param name="timestamp">时间戳 (单位: 秒)</param>
        /// <param name="isLocal">是否为本地时间, 否则为UTC时间</param>
        /// <returns></returns>
        public static DateTime GetDateTime(long timestamp, bool isLocal = true)
        {
            var timeZone = isLocal ? TimeZoneInfo.Local : TimeZoneInfo.Utc;
            DateTime startTime = TimeZoneInfo.ConvertTimeFromUtc(new DateTime(1970, 1, 1, 0, 0, 0), timeZone);// 当地时区
            return startTime.AddSeconds(timestamp);
        }
    }
}
